"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useUx4iot = exports.Ux4iotContextProvider = exports.Ux4iotContext = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var Ux4iot_1 = require("./base/Ux4iot");
exports.Ux4iotContext = (0, react_1.createContext)({
    ux4iot: undefined,
    sessionId: '',
});
var Ux4iotContextProvider = function (_a) {
    var options = _a.options, children = _a.children;
    var optionsRef = (0, react_1.useRef)(options);
    var _b = (0, react_1.useState)(''), sessionId = _b[0], setSessionId = _b[1];
    var _c = (0, react_1.useState)(), ux4iot = _c[0], setUx4iot = _c[1];
    function onSessionId(sessionId) {
        setSessionId(sessionId);
    }
    var initialize = (0, react_1.useCallback)(function () { return __awaiter(void 0, void 0, void 0, function () {
        var ux4iot_1, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!!ux4iot) return [3 /*break*/, 4];
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, Ux4iot_1.Ux4iot.create(optionsRef.current, onSessionId)];
                case 2:
                    ux4iot_1 = _a.sent();
                    setUx4iot(ux4iot_1);
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _a.sent();
                    console.error(error_1);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    }); }, [ux4iot]);
    (0, react_1.useEffect)(function () {
        optionsRef.current = options;
    }, [options]);
    (0, react_1.useEffect)(function () {
        initialize();
        return function () {
            if (ux4iot) {
                ux4iot.destroy();
                setUx4iot(undefined);
                setSessionId('');
            }
        };
    }, [ux4iot, initialize]);
    return ((0, jsx_runtime_1.jsx)(exports.Ux4iotContext.Provider, __assign({ value: { ux4iot: ux4iot, sessionId: sessionId } }, { children: children })));
};
exports.Ux4iotContextProvider = Ux4iotContextProvider;
var useUx4iot = function () {
    return (0, react_1.useContext)(exports.Ux4iotContext);
};
exports.useUx4iot = useUx4iot;
