import { DeviceMethodParams } from 'azure-iothub';
import { GRANT_RESPONSES, InitializationOptions } from './types';
import { GrantRequest, IoTHubResponse, LastValueConnectionStateResponse, LastValueDeviceTwinResponse, LastValueTelemetryResponse, SubscriptionRequest } from './ux4iot-shared';
export declare class Ux4iotApi {
    private axiosInstance;
    private grantRequestFunction;
    private ux4iotUrl;
    private sessionId?;
    constructor(initializationOptions: InitializationOptions);
    private defaultGrantRequestFunction;
    setSessionId(sessionId: string): void;
    getSessionId(): Promise<string>;
    getSocketURL(sessionId: string): string;
    requestGrant(grantBase: Omit<GrantRequest, 'sessionId'>): Promise<GRANT_RESPONSES>;
    subscribe(subscriptionRequestBase: Omit<SubscriptionRequest, 'sessionId'>): Promise<void>;
    unsubscribe(subscriptionRequestBase: Omit<SubscriptionRequest, 'sessionId'>): Promise<void>;
    subscribeAll(subscriptionRequests: SubscriptionRequest[]): Promise<void>;
    unsubscribeAll(subscriptionRequests: SubscriptionRequest[]): Promise<void>;
    getLastTelemetryValue(deviceId: string, telemetryKey: string): Promise<LastValueTelemetryResponse>;
    getLastTelemetryValues(deviceId: string, telemetryKeys: string[]): Promise<LastValueTelemetryResponse>;
    getLastDeviceTwin(deviceId: string): Promise<LastValueDeviceTwinResponse>;
    getLastConnectionState(deviceId: string): Promise<LastValueConnectionStateResponse>;
    invokeDirectMethod(deviceId: string, options: DeviceMethodParams): Promise<IoTHubResponse | void>;
    patchDesiredProperties(deviceId: string, desiredPropertyPatch: Record<string, unknown>): Promise<IoTHubResponse | void>;
}
