import { ConnectionStateMessage, DeviceTwinMessage, TelemetryMessage, D2CMessage, GrantRequest, SubscriptionRequest } from './ux4iot-shared';
export declare function makeSubKey(...args: unknown[]): string;
export declare function parseSubKey(subscriberKey: string): Record<string, string>;
export declare function deserializeTelemetrySubscriberState(subscriberId: string, state: Record<string, any>): Record<string, string[]>;
export declare function deserializeSubscriberState(subscriberId: string, state: Record<string, any>): string[];
export declare function cleanSubId<T extends Record<string, any>>(id: string, subscribers: T): T;
export declare function printDevModeWarning(): void;
export declare function isConnectionStateMessage(message: Record<string, unknown>): message is ConnectionStateMessage;
export declare function isD2CMessage(message: Record<string, unknown>): message is D2CMessage;
export declare function isDeviceTwinMessage(message: Record<string, unknown>): message is DeviceTwinMessage;
export declare function isTelemetryMessage(message: Record<string, unknown>): message is TelemetryMessage;
export declare function grantRequestsEqual(g1: GrantRequest, g2: GrantRequest): boolean;
export declare function getGrantFromSubscriptionRequest(subscriptionRequest: SubscriptionRequest): GrantRequest;
