import { Reducer } from 'react';
import { CachedValueType } from './base/ux4iot-shared';
declare type DeviceId = string;
declare type TelemetryKey = string;
export declare type TelemetryValue = {
    value: CachedValueType;
    timestamp: string | undefined;
};
export declare type TelemetryState = Record<DeviceId, Record<TelemetryKey, TelemetryValue>>;
export declare type ADD_DATA_ACTION = {
    type: 'ADD_DATA';
    deviceId: string;
    message: Record<string, any>;
    timestamp?: string;
};
export declare type TelemetryAction = ADD_DATA_ACTION;
export declare const telemetryReducer: Reducer<TelemetryState, TelemetryAction>;
export {};
