"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.telemetryReducer = void 0;
function isObject(value) {
    return typeof value === 'object' && value !== null && !Array.isArray(value);
}
var telemetryReducer = function (state, action) {
    var _a;
    switch (action.type) {
        case 'ADD_DATA': {
            var deviceId = action.deviceId, message = action.message, timestamp = action.timestamp;
            var nextDeviceState = __assign({}, state[deviceId]);
            for (var _i = 0, _b = Object.entries(message); _i < _b.length; _i++) {
                var _c = _b[_i], telemetryKey = _c[0], telemetryValue = _c[1];
                nextDeviceState[telemetryKey] = isObject(telemetryValue)
                    ? { value: telemetryValue.value, timestamp: telemetryValue.timestamp }
                    : { value: telemetryValue, timestamp: timestamp };
            }
            return __assign(__assign({}, state), (_a = {}, _a[deviceId] = nextDeviceState, _a));
        }
        default:
            return state;
    }
};
exports.telemetryReducer = telemetryReducer;
