"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useMultiTelemetry = void 0;
var react_1 = require("react");
var uuid_1 = require("uuid");
var telemetryState_1 = require("./telemetryState");
var Ux4iotContext_1 = require("./Ux4iotContext");
function getSubscriptionRequest(deviceId, telemetryKey, sessionId) {
    return {
        sessionId: sessionId,
        deviceId: deviceId,
        telemetryKey: telemetryKey,
        type: 'telemetry',
    };
}
var useMultiTelemetry = function (options) {
    var onData = options.onData, onGrantError = options.onGrantError, onSubscriptionError = options.onSubscriptionError, initialSubscribers = options.initialSubscribers;
    var _a = (0, react_1.useContext)(Ux4iotContext_1.Ux4iotContext), ux4iot = _a.ux4iot, sessionId = _a.sessionId;
    var _b = (0, react_1.useState)({}), currentSubscribers = _b[0], setCurrentSubscribers = _b[1];
    var initialSubscribersRef = (0, react_1.useRef)(initialSubscribers);
    var onDataRef = (0, react_1.useRef)(onData);
    var onGrantErrorRef = (0, react_1.useRef)(onGrantError);
    var onSubscriptionErrorRef = (0, react_1.useRef)(onSubscriptionError);
    var subscriptionId = (0, react_1.useRef)((0, uuid_1.v4)());
    (0, react_1.useEffect)(function () {
        initialSubscribersRef.current = initialSubscribers;
    }, [initialSubscribers]);
    (0, react_1.useEffect)(function () {
        onDataRef.current = onData;
        onGrantErrorRef.current = onGrantError;
        onSubscriptionErrorRef.current = onSubscriptionError;
    }, [onData, onGrantError, onSubscriptionError]);
    var _c = (0, react_1.useReducer)(telemetryState_1.telemetryReducer, {}), telemetry = _c[0], setTelemetry = _c[1];
    var onTelemetry = (0, react_1.useCallback)(function (deviceId, message, timestamp) {
        var _a;
        if (message) {
            setTelemetry({ type: 'ADD_DATA', deviceId: deviceId, message: message, timestamp: timestamp });
            (_a = onDataRef.current) === null || _a === void 0 ? void 0 : _a.call(onDataRef, deviceId, message, timestamp);
        }
    }, [setTelemetry]);
    var addTelemetry = (0, react_1.useCallback)(function (deviceId, telemetryKeys) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!ux4iot) return [3 /*break*/, 2];
                    return [4 /*yield*/, ux4iot.subscribeAllTelemetry(sessionId, deviceId, telemetryKeys, subscriptionId.current, onTelemetry, onSubscriptionErrorRef.current, onGrantErrorRef.current)];
                case 1:
                    _a.sent();
                    setCurrentSubscribers(ux4iot.getSubscriberIdSubscriptions(subscriptionId.current));
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    }); }, [ux4iot, onTelemetry, sessionId]);
    var removeTelemetry = (0, react_1.useCallback)(function (deviceId, telemetryKeys) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!ux4iot) return [3 /*break*/, 2];
                    return [4 /*yield*/, ux4iot.unsubscribeAllTelemetry(sessionId, deviceId, telemetryKeys, subscriptionId.current, onSubscriptionErrorRef.current, onGrantErrorRef.current)];
                case 1:
                    _a.sent();
                    setCurrentSubscribers(ux4iot.getSubscriberIdSubscriptions(subscriptionId.current));
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    }); }, [ux4iot, sessionId]);
    var toggleTelemetry = (0, react_1.useCallback)(function (deviceId, telemetryKey) { return __awaiter(void 0, void 0, void 0, function () {
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!ux4iot) return [3 /*break*/, 5];
                    if (!ux4iot.hasSubscription(subscriptionId.current, getSubscriptionRequest(deviceId, telemetryKey, sessionId))) return [3 /*break*/, 2];
                    return [4 /*yield*/, removeTelemetry(deviceId, [telemetryKey])];
                case 1:
                    _a = _b.sent();
                    return [3 /*break*/, 4];
                case 2: return [4 /*yield*/, addTelemetry(deviceId, [telemetryKey])];
                case 3:
                    _a = _b.sent();
                    _b.label = 4;
                case 4:
                    _a;
                    _b.label = 5;
                case 5: return [2 /*return*/];
            }
        });
    }); }, [ux4iot, addTelemetry, removeTelemetry, sessionId]);
    var isSubscribed = (0, react_1.useCallback)(function (deviceId, telemetryKey) {
        if (ux4iot) {
            return ux4iot.hasSubscription(subscriptionId.current, getSubscriptionRequest(deviceId, telemetryKey, sessionId));
        }
        else {
            return false;
        }
    }, [ux4iot, sessionId]);
    (0, react_1.useEffect)(function () {
        function initSubscribe() {
            return __awaiter(this, void 0, void 0, function () {
                var _i, _a, _b, deviceId, telemetryKeys;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            if (!(ux4iot && sessionId && initialSubscribersRef.current)) return [3 /*break*/, 5];
                            _i = 0, _a = Object.entries(initialSubscribersRef.current);
                            _c.label = 1;
                        case 1:
                            if (!(_i < _a.length)) return [3 /*break*/, 4];
                            _b = _a[_i], deviceId = _b[0], telemetryKeys = _b[1];
                            return [4 /*yield*/, addTelemetry(deviceId, telemetryKeys)];
                        case 2:
                            _c.sent();
                            _c.label = 3;
                        case 3:
                            _i++;
                            return [3 /*break*/, 1];
                        case 4:
                            setCurrentSubscribers(ux4iot.getSubscriberIdSubscriptions(subscriptionId.current));
                            _c.label = 5;
                        case 5: return [2 /*return*/];
                    }
                });
            });
        }
        initSubscribe();
    }, [ux4iot, addTelemetry, sessionId]);
    (0, react_1.useEffect)(function () {
        var subId = subscriptionId.current;
        return function () {
            ux4iot === null || ux4iot === void 0 ? void 0 : ux4iot.removeSubscriberId(subId, sessionId);
        };
    }, [ux4iot, sessionId]);
    return {
        telemetry: telemetry,
        addTelemetry: addTelemetry,
        removeTelemetry: removeTelemetry,
        toggleTelemetry: toggleTelemetry,
        isSubscribed: isSubscribed,
        currentSubscribers: currentSubscribers,
    };
};
exports.useMultiTelemetry = useMultiTelemetry;
