"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTelemetry = void 0;
var react_1 = require("react");
var useSubscription_1 = require("./useSubscription");
var useTelemetry = function (deviceId, telemetryKey, options) {
    if (options === void 0) { options = {}; }
    var onDataRef = (0, react_1.useRef)(options.onData);
    var _a = (0, react_1.useState)(), value = _a[0], setValue = _a[1];
    (0, react_1.useEffect)(function () {
        onDataRef.current = options.onData;
    }, [options.onData]);
    var onTelemetry = (0, react_1.useCallback)(function (deviceId, message, timestamp) {
        var _a;
        var maybeValue = message === null || message === void 0 ? void 0 : message[telemetryKey];
        if (maybeValue !== undefined) {
            setValue(maybeValue);
            (_a = onDataRef.current) === null || _a === void 0 ? void 0 : _a.call(onDataRef, deviceId, maybeValue, timestamp);
        }
    }, [telemetryKey]);
    var subscriptionRequest = (0, react_1.useCallback)(function (sessionId) {
        return { deviceId: deviceId, telemetryKey: telemetryKey, type: 'telemetry', sessionId: sessionId };
    }, [deviceId, telemetryKey]);
    (0, useSubscription_1.useSubscription)(options, onTelemetry, subscriptionRequest);
    return value;
};
exports.useTelemetry = useTelemetry;
